"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.combine = combine;
const Result_1 = require("../../Result");
function combine(...args) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = new Result_1.Result();
        const tries = args.slice(0, -1);
        const func = args[args.length - 1];
        const values = [];
        for (const v of tries) {
            try {
                values.push(yield v.get());
            }
            catch (err) {
                return result.setError(err);
            }
        }
        // @ts-ignore
        return result.setValue(yield func(...values));
    });
}
